VERSION 5.00
Begin VB.UserControl pSpinEdit 
   BackColor       =   &H80000005&
   BorderStyle     =   1  'Fixed Single
   ClientHeight    =   570
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   2040
   ScaleHeight     =   38
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   136
   ToolboxBitmap   =   "SpinEdit.ctx":0000
   Begin VB.VScrollBar scrValue 
      Height          =   252
      Left            =   1680
      TabIndex        =   1
      Top             =   120
      Width           =   192
   End
   Begin VB.TextBox txtValue 
      BorderStyle     =   0  'None
      Height          =   192
      Left            =   0
      TabIndex        =   0
      TabStop         =   0   'False
      Top             =   120
      Width           =   1572
   End
End
Attribute VB_Name = "pSpinEdit"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Private Declare Function GetSystemMetrics Lib "user32" (ByVal nIndex As Long) As Long
Private Declare Function GetCapture Lib "user32" () As Long

Private Const SM_CXVSCROLL = 2

'Event Declarations:
Event Change() 'MappingInfo=txtValue,txtValue,-1,Change
Attribute Change.VB_Description = "Occurs when the contents of a control have changed."
'--------------------------------------------------------------------------------
'increment or decrement the value shown in the text box when user clicks
'the scroll bar.
'--------------------------------------------------------------------------------
Private Sub scrvalue_Change()
    
    If GetCapture = scrValue.hwnd Then                  'make sure scroll bar was clicked
        txtValue.Text = Trim$(Str$(scrValue.Value))     'assign the value
        txtValue_GotFocus                               'call set focus event to select all text
    End If
    
End Sub

Private Sub scrValue_GotFocus()

    txtValue.SetFocus

End Sub

'--------------------------------------------------------------------------------
'Select all text when control receives focus
'--------------------------------------------------------------------------------
Private Sub txtValue_GotFocus()
    
    txtValue.SelStart = 0
    txtValue.SelLength = Len(txtValue.Text)
    
    scrValue.TabStop = False 'stops scroll bar from keeping focus within the control
                             'this is set to true on the user control's ExitFocus
                             'event so clicking the scroll bar can get focus back.
    
End Sub
'--------------------------------------------------------------------------------
'Validate key pressed, and take appropriate action
'--------------------------------------------------------------------------------
Private Sub txtValue_KeyDown(KeyCode As Integer, Shift As Integer)
    
    Select Case KeyCode
    
        Case vbKeyUp
        
            'decrement the value, and update the display
            If scrValue.Value - scrValue.SmallChange > scrValue.Min Then
                scrValue.Value = scrValue.Value - scrValue.SmallChange
            Else
                scrValue.Value = scrValue.Min
            End If
            txtValue.Text = Trim$(Str$(scrValue.Value))
            KeyCode = 0
            
        Case vbKeyDown
        
            'increment the value, and update the display
            If scrValue.Value + scrValue.SmallChange < scrValue.Max Then
                scrValue.Value = scrValue.Value + scrValue.SmallChange
            Else
                scrValue.Value = scrValue.Max
            End If
            txtValue.Text = Trim$(Str$(scrValue.Value))
            KeyCode = 0
            
        Case Else
            'nothing to do
            
    End Select

End Sub
'--------------------------------------------------------------------------------
'Validate each keypress, and update the scroll bar value
'--------------------------------------------------------------------------------
Private Sub txtValue_KeyPress(KeyAscii As Integer)
    
    If (KeyAscii < 48 Or KeyAscii > 57) And KeyAscii <> 8 Then 'ignore invalid keypresses
        KeyAscii = 0 'clear invalid keypress
    End If

End Sub
'--------------------------------------------------------------------------------
'correct for any invalid value entered by user by setting text to the scroll
'bar value which has already been validated in the change event
'--------------------------------------------------------------------------------
Private Sub txtValue_LostFocus()

    txtValue.Text = Trim$(Str$(scrValue.Value))     'assign the value
    
End Sub

Private Sub UserControl_ExitFocus()

    scrValue.TabStop = True 'required so a mouse click on the scrollbar can
                            'get focus, otherwise any other control on the
                            'form will keep the focus
                            
End Sub


Private Sub UserControl_Paint()

    Dim nTxtWidth As Integer
    
    txtValue.BackColor = UserControl.BackColor
    txtValue.ForeColor = UserControl.ForeColor
    scrValue.Width = GetSystemMetrics(SM_CXVSCROLL)
    
    With UserControl.Font
        .Name = txtValue.Font.Name
        .Size = txtValue.Font.Size
        .Bold = txtValue.Font.Bold
    End With
    
    If UserControl.Width < 32 * Screen.TwipsPerPixelX Then
        UserControl.Width = 32 * Screen.TwipsPerPixelX
    End If
    
    If UserControl.ScaleWidth - scrValue.Width - 3 > 5 Then
        nTxtWidth = UserControl.ScaleWidth - scrValue.Width - 3
    Else
        nTxtWidth = 5
    End If
    
    UserControl.Height = (UserControl.TextHeight("1") + 8) * Screen.TwipsPerPixelY
    txtValue.Move 1, 1, nTxtWidth, UserControl.ScaleHeight - 2
    scrValue.Move UserControl.ScaleWidth - scrValue.Width, 0, scrValue.Width, UserControl.ScaleHeight

End Sub

'--------------------------------------------------------------------------------
'Validate the number entered by the user against the min and max values for
'the scrollbar control, and raise the user event
'--------------------------------------------------------------------------------
Private Sub txtValue_Change()
    
    Dim iResultVal As Long, nIncrement As Integer
    nIncrement = scrValue.SmallChange
    iResultVal = Val(txtValue.Text)
    
    If GetCapture <> scrValue.hwnd Then 'make sure edit control is being edited
    
        'adjust value for incremental steps if necessary
        
        If iResultVal <> (Int(iResultVal / nIncrement) * nIncrement) Then
            iResultVal = (Int(iResultVal / nIncrement) * nIncrement) + nIncrement
        End If
        
        Select Case iResultVal
        
            Case Is < scrValue.Min                          'value is below the allowed range, so
                iResultVal = scrValue.Min                   'reset value to minimum value
                
            Case Is > scrValue.Max                          'value exceeds the allowed range, so
                iResultVal = scrValue.Max                   'reset value to the maximum value
                
            Case Else
            'value is within acceptable range
            
        End Select
        
        scrValue.Value = iResultVal     'update the scroll bar value
        
    End If
    
    '--------------------------------------------------------------------------------
    'Raise the user event
    '--------------------------------------------------------------------------------

    RaiseEvent Change
    
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=scrValue,scrValue,-1,Max
Public Property Get Max() As Integer
Attribute Max.VB_Description = "Returns/sets a scroll bar position's maximum Value property setting."
    Max = scrValue.Max
End Property

Public Property Let Max(ByVal New_Max As Integer)
    scrValue.Max() = New_Max
    PropertyChanged "Max"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=scrValue,scrValue,-1,Min
Public Property Get Min() As Integer
Attribute Min.VB_Description = "Returns/sets a scroll bar position's maximum Value property setting."
    Min = scrValue.Min
End Property

Public Property Let Min(ByVal New_Min As Integer)
    scrValue.Min() = New_Min
    PropertyChanged "Min"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=scrValue,scrValue,-1,Value
Public Property Get Value() As Integer
Attribute Value.VB_Description = "Returns/sets the value of an object."
    Value = scrValue.Value
    txtValue.Text = Trim$(Str$(Value))
End Property

Public Property Let Value(ByVal New_Value As Integer)
    
    If New_Value > scrValue.Max Or New_Value < scrValue.Min Then
        ShowValueError
    Else
        scrValue.Value() = New_Value
        PropertyChanged "Value"
        txtValue.Text = Trim$(Str$(Value))
    End If
    
End Property

'Load property values from storage
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)

    'Trap for corrupted or invalid file
    On Error Resume Next

    Set Font = PropBag.ReadProperty("Font", Ambient.Font)
    scrValue.Max = PropBag.ReadProperty("Max", 32767)
    scrValue.Min = PropBag.ReadProperty("Min", 0)
    scrValue.Value = PropBag.ReadProperty("Value", 0)
    UserControl.Enabled = PropBag.ReadProperty("Enabled", True)
    scrValue.SmallChange = PropBag.ReadProperty("Increment", 1)
    UserControl.ForeColor = PropBag.ReadProperty("ForeColor", &H80000012)
    UserControl.BackColor = PropBag.ReadProperty("BackColor", &H80000005)
    
    'Derived values
    
    txtValue.Text = Trim$(Str$(scrValue.Value))
    txtValue.Enabled = UserControl.Enabled
    scrValue.Enabled = UserControl.Enabled
    txtValue.MaxLength = Len(Str$(scrValue.Max))
    
    If Err Then
        MsgBox "Property Load Error", vbExclamation
    End If
    
    On Error GoTo 0
    
End Sub

'Write property values to storage
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)

    Call PropBag.WriteProperty("Font", Font, Ambient.Font)
    Call PropBag.WriteProperty("Max", scrValue.Max, 32767)
    Call PropBag.WriteProperty("Min", scrValue.Min, 0)
    Call PropBag.WriteProperty("Value", scrValue.Value, 0)
    Call PropBag.WriteProperty("Enabled", UserControl.Enabled, True)
    Call PropBag.WriteProperty("Increment", scrValue.SmallChange, 1)
    Call PropBag.WriteProperty("ForeColor", UserControl.ForeColor, &H80000012)
    Call PropBag.WriteProperty("BackColor", UserControl.BackColor, &H80000005)
    
End Sub
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,hWnd
Public Property Get hwnd() As Long
Attribute hwnd.VB_Description = "Returns a handle (from Microsoft Windows) to an object's window."
    hwnd = UserControl.hwnd
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,Enabled
Public Property Get Enabled() As Boolean
Attribute Enabled.VB_Description = "Returns/sets a value that determines whether an object can respond to user-generated events."
    Enabled = UserControl.Enabled
    txtValue.Enabled = Enabled
    scrValue.Enabled = Enabled
End Property

Public Property Let Enabled(ByVal New_Enabled As Boolean)
    UserControl.Enabled = New_Enabled
    txtValue.Enabled = New_Enabled
    scrValue.Enabled = New_Enabled
    PropertyChanged "Enabled"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,Refresh
Public Sub Refresh()
Attribute Refresh.VB_Description = "Forces a complete repaint of a object."
    UserControl.Refresh
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=scrValue,scrValue,-1,SmallChange
Public Property Get Increment() As Integer
Attribute Increment.VB_Description = "Returns/sets amount of change to Value property in a scroll bar when user clicks a scroll arrow."
    Increment = scrValue.SmallChange
End Property

Public Property Let Increment(ByVal New_Increment As Integer)
    If New_Increment < 1 Or New_Increment > scrValue.Max - scrValue.Min Then
        ShowValueError
    Else
        scrValue.SmallChange() = New_Increment
        PropertyChanged "Increment"
    End If
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txtValue,txtValue,-1,Font
Public Property Get Font() As Font
Attribute Font.VB_Description = "Returns a Font object."
Attribute Font.VB_UserMemId = -512
    Set Font = txtValue.Font
End Property

Public Property Set Font(ByVal New_Font As Font)
    Set txtValue.Font = New_Font
    PropertyChanged "Font"
    UserControl_Paint
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,ForeColor
Public Property Get ForeColor() As OLE_COLOR
Attribute ForeColor.VB_Description = "Returns/sets the foreground color used to display text and graphics in an object."
    ForeColor = UserControl.ForeColor
End Property

Public Property Let ForeColor(ByVal New_ForeColor As OLE_COLOR)
    UserControl.ForeColor() = New_ForeColor
    PropertyChanged "ForeColor"
    UserControl_Paint
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,BackColor
Public Property Get BackColor() As OLE_COLOR
Attribute BackColor.VB_Description = "Returns/sets the background color used to display text and graphics in an object."
    BackColor = UserControl.BackColor
End Property

Public Property Let BackColor(ByVal New_BackColor As OLE_COLOR)
    UserControl.BackColor() = New_BackColor
    PropertyChanged "BackColor"
    UserControl_Paint
End Property

Private Sub ShowValueError()
    
    If Ambient.UserMode Then
        Err.Raise 380
    End If

End Sub
